# syntax = docker/dockerfile:1

# Adjust BUN_VERSION as desired
ARG BUN_VERSION=1.3.14
FROM oven/bun:${BUN_VERSION}-slim AS base

LABEL fly_launch_runtime="Bun"

# Bun app lives here
WORKDIR /app

# Set production environment
ENV NODE_ENV="production"


# Throw-away build stage to reduce size of final image
FROM base AS build

# Install packages needed to build node modules
RUN apt-get update -qq && \
    apt-get install --no-install-recommends -y build-essential pkg-config python-is-python3

# Install node modules
COPY bun.lock package.json ./
COPY apps/api/package.json apps/api/package.json
COPY apps/portal/package.json apps/portal/package.json
COPY packages/calculator/package.json packages/calculator/package.json
COPY packages/commerce/package.json packages/commerce/package.json
COPY packages/domain/package.json packages/domain/package.json
RUN bun install

# Copy application code
COPY . .

# Build application
RUN bun run build:portal


# Final stage for app image
FROM base

# Copy built server
COPY --from=build /app/apps/portal/build /app/build

# Start the server by default, this can be overwritten at runtime
ENV PORT=8080
EXPOSE 8080
CMD [ "bun", "run", "build/index.js" ]
